#include <cassert>
#include <cstdlib>
#include "Nim.hpp"

Nim::Nim() :
   heap_size(rand() % 10 + 10), whose_turn(PLAYER1)
{
}

Nim::Nim(int initial_size) :
   heap_size(initial_size), whose_turn(PLAYER1)
{
   assert(initial_size > 0);
}

bool Nim::finished() const {
   return heap_size == 0;
}

int Nim::size_of_heap() const {
   return heap_size;
}

player Nim::winner() const {
   assert(heap_size == 0);
   return other_player();
}

player Nim::next_player() const {
   assert(heap_size > 0);
   return whose_turn;
}

bool Nim::valid(int move) const {
   return move > 0 && move <= 3 && move <= heap_size;
}

void Nim::perform_move(int move) {
   assert(valid(move));
   heap_size -= move;
   whose_turn = other_player();
}

player Nim::other_player() const {
   if (whose_turn == PLAYER1) {
      return PLAYER2;
   } else {
      return PLAYER1;
   }
}
