#include <iostream>
#include <ctime>
#include <cstdlib>
#include "Nim.hpp"

using namespace std;

int main() {
   srand(time(0)); // seed random generator
   Nim game;

   // explain the rules
   cout << "*** Nimm-Spiel ***" << endl;
   cout << "Ein Haufen von " << game.size_of_heap()
      << " Staebchen liegt vor." << endl;
   cout << "In jedem Zug koennen zwischen 1 und 3 Staebchen entfernt werden."
      << endl;
   cout << "Wer die letzten Staebchen entfernt, hat gewonnen." << endl;

   // free choice of the beginning player
   int choice;
   player human;
   cout << "Wer soll anfangen? 1=Sie 2=Computer" << endl;
   if (cin >> choice && (choice == 1 || choice == 2)) {
      switch (choice) {
         case 1: human = PLAYER1; break;
         case 2: human = PLAYER2; break;
      }
   } else {
      cout << "Das war wohl nichts!" << endl; return 0;
   }

   while (!game.finished()) {
      cout << "Noch sind es " << game.size_of_heap() << " Staebchen." << endl;
      int move;
      if (game.next_player() == human) {
	 for(;;) {
	    if (!(cout << "Ihr Zug: " && cin >> move)) return 1;
	    if (game.valid(move)) break;
	    cout << "Ihr Zug war ungltig!" << endl;
	 }
      } else {
	 if (game.size_of_heap() <= 3) {
	    move = game.size_of_heap();
	 } else {
	    int modulo = game.size_of_heap() % 4;
	    if (modulo < 1) {
	       // oh well... lets try a random move
	       move = rand() % 3 + 1;
	    } else {
	       // this looks fine :)
	       move = modulo;
	    }
	 }
	 cout << "Der Computer nimmt " << move << " Staebchen." << endl;
      }
      game.perform_move(move);
   }
   if (game.finished()) {
      if (game.winner() == human) {
	 cout << "Herzlichen Glckwunsch, Sie haben gewonnen!" << endl;
      } else {
	 cout << "Das Spiel geht an mich!" << endl;
      }
   }
}
